/*
 * Copyright (C) 1996-2003 LAAS/CNRS 
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *    - Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *    - Redistributions in binary form must reproduce the above
 *      copyright notice, this list of conditions and the following
 *      disclaimer in the documentation and/or other materials provided
 *      with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 */
/* $LAAS$ */

#ifndef _GDHE_CLIENT_PROT_H
#define _GDHE_CLIENT_PROT_H

#ifdef __cplusplus
extern "C" {
#endif
    
extern int get_connection ( char *server_name );
extern int eval_expression ( char *expr );
extern int disconnect ( void );

#ifdef __cplusplus
};
#endif


#ifndef __cplusplus
extern int place_robot ( int which, position* posp );
extern int erase_robot ( int which );
extern int exec_trajectory ( int which, trajectory* trajp );
extern int set_platform ( int which, angle* angp );
extern int move_platform ( int which, angle* angp );
extern int place_diamond ( v_position* vposp );
extern int erase_diamond ( void );
extern int place_doors ( v_segment* vsegp );
extern int erase_doors ( void );
extern int place_walls ( int which, int id, v_segment* vsegp );
extern int place_walls_rel ( int which, int id, v_segment* vsegp );
extern int place_walls_acc ( int which, int id, v_segment* vsegp );
extern int erase_walls ( int which, int id );
extern int place_free_space ( polygon* polp );
extern int erase_free_space ( void );
extern int place_trajectory ( trajectory* trajp );
extern int erase_trajectory ( void );
extern int place_path ( trajectory* trajp );
extern int erase_path ( void );
extern int place_robot_trajectory ( int which, trajectory *trajp );
extern int erase_robot_trajectory ( int which );
extern int place_robot_path ( int which, trajectory *trajp );
extern int erase_robot_path ( int which );
extern int place_rs_trajectory ( int which, int id, rs_trajectory *trajp );
extern int erase_rs_trajectory ( int which, int id );
extern int place_goal_o ( position* posp );
extern int place_goal_no ( position* posp );
extern int erase_goal ( void );
extern int video_on ( int which );
extern int video_off ( int which );
extern int laser_on ( int which );
extern int laser_off ( int which );
extern int place_dependency_edge ( int from, int to );
extern int erase_dependency_edge ( int from, int to );
extern int place_dependency_cycle ( int which, dependency_cycle *cyclep );
extern int erase_dependency_cycle ( int which );
extern int place_mission_goal ( int which, char *message );
extern int erase_mission_goal ( int which );
#ifdef HAVE_GDHE_TERRAIN
extern int place_terrain ( int which, GDHE_MNT *terrain );
extern int erase_terrain ( int which );
#endif /* HAVE_GDHE_TERRAIN */
extern int select_robot_type ( int which, int *type );
extern int update_per_obst ( int which, polygon *pols );
extern int erase_per_obst ( int which );
extern int close_all ( void );
extern char *getenv_server ( void );
extern XDR get_connected_xdr ( void );
extern void reset_connected_xdr ( void );
#endif

#endif /* _GDHE_CLIENT_PROT_H */
