# 
# Copyright (C) 1996-2001 LAAS/CNRS 
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
#    - Redistributions of source code must retain the above copyright
#      notice, this list of conditions and the following disclaimer.
#    - Redistributions in binary form must reproduce the above
#      copyright notice, this list of conditions and the following
#      disclaimer in the documentation and/or other materials provided
#      with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
# 
# $LAAS$
#----------------------------------------------------------------------
package provide Gdhe::models 1.0

#
# Sonars for P3DX
#

proc p3dxFacette {} {
    pushMatrix
    # Positionne la facette verticalement
    translate 0 0 0.155
    rotate 90 0 0 1
    rotate 90 1 0 0
 
    # Le rectangle support
    color 200 20 20
    polygon 4 -0.03 0.0 0.03 0.0 0.03 0.06 -0.03 0.06

    #  US
    color 200 200 80
    cylinder 0 0.03 0 z 0.05 0.002

    # support du bumper
#    color 20 20 20 
 #   box 0 0.01 0 0.08 0.02 0.01
  #  color 150 0 0 
    # Bumper
   # box 0 0.01 0.01 0.08 0.02 0.01
   # popMatrix

}


proc degToRad {x} {
    return [expr $x*3.1415926535/180.0]
}

objectDelete p3dx
objectDelete ScoutCam
objectDelete ScoutCamSupport

proc p3dx {} {
    concave False
    cullFace True
    object p3dx {

	#  8 front sonars
	for { set i 0 } { $i < 3 } { incr i } {
	    pushMatrix
	    rotate [expr -10+(-180.0/9)*$i ] 0 0 1
	    translate 0.168 0 0 
	    p3dxFacette
	    popMatrix
	    pushMatrix
	    rotate [expr 10-(-180.0/9)*$i ] 0 0 1
	    translate 0.168 0 0 
	    p3dxFacette
	    popMatrix
	}
	
	pushMatrix
	rotate 90 0 0 1
	translate 0.15 -0.05 0 
	p3dxFacette
	popMatrix
	pushMatrix
	rotate 90 0 0 1
	translate -0.15 -0.05 0 
	p3dxFacette
	popMatrix

	# Calcul des faces superieure et inferieure
#	set upper {}
#	set lower {}
#	for { set i 0 } { $i < 16 } { incr i } {
#	    set theta [degToRad [expr (360./16)*$i + 360./32. ]]
#	    set x [expr 0.22*cos($theta)]
#	    set y [expr 0.22*sin($theta)]
#	    set upper [concat $upper $x $y]
#	    set lower [concat $x $y $lower]
#	}

	# Affichage de faces
#	color 20 20 20
#	pushMatrix
#	translate 0 0 0.221
#	eval [concat polygon 16 $lower]
#	translate 0 0 0.001
#	eval [concat polygon 16 $upper]
#	popMatrix

	# Robot base
	color 200 0 0
	prism 8 \
	    0 0 0.155 \
	    -0.215 -0.1025 0.06 \
	    -0.185 -0.1325 0.06 \
	    0.095 -0.1325 0.06 \
	    0.135 -0.08 0.06 \
	    0.135 0.08 0.06 \
	    0.095 0.1325 0.06 \
	    -0.185 0.1325 0.06 \
	    -0.215 0.1025 0.06

	# Right wheel
	color 40 40 40 
	cylinder 0 -0.167 0.075 y -0.15  0.13 0.03
	cylinder 0 -0.19 0.075 y  0.13 -0.15 0.03
	color 200 200 20
	cylinder 0 -0.191 0.075 y 0.05 0.001


	# Left wheel
	color 40 40 40
	cylinder 0 0.144 0.075 y  0.13  -0.15 0.03
	cylinder 0 0.167 0.075 y  -0.15 0.13 0.03
	color 200 200 80
	cylinder 0 0.194 0.075 y 0.05 0.001

	# Caster wheel
	color 40 40 40
	cylinder -0.185 -0.015 0.035 y 0.05 0.03

	# Antenne
	color 40 40 40

	cylinder 0 0.13 0.22 z 0.005 0.04
	cylinder 0 0.13 0.26 z 0.002 0.02

	sphere 0 0.13 0.283 0.004

#	color 200 0 0
#	rotate 90 1 0 0
#	translate 0 0 0.20
#	polygon 4 0.02 0.215 -0.03 0.215 -0.03 0.07 0.01 0.07
#	translate 0 0 -0.4
#	polygon 4 0.02 0.215 0.01 0.07 -0.03 0.07 -0.03 0.215  


	# sick
	color 20 20 200
	box .095 .0 .323 .15 .15 .07
	box .045 .0 .243 .05 .15 .08
	box .095 .0 .223 .15 .15 .02
	color 20 20 20
	box .11 .0 .25 .08 .10 .08


    }
}

#
# Camera sur un support Nomadic
#
proc scout_cam {{a1 0} {a2 0}} {
    pushMatrix
    translate 0.11 0 0.34
    object ScoutCamSupport {
	# prtie fixe du support
	color 20 20 20
	cylinder 0 0 0 z -0.03 0.02 0.05
    } 
    translate 0 0 0.05
    rotate $a1 0 0 1
    rotate $a2 0 1 0
    object ScoutCam {
	# PArtie mobile du support
	color 20 20 20
	cylinder 0 0 0 z 0.04 -0.04 0.01
	translate 0.02 0 0.01
	# camera
	color 50 50 50
	box -0.05 0.0 0.0 0.10 0.05 0.04
	color 70 70 70
	cylinder 0.0 0.0 0.022 x 0.028 0.01
	cylinder 0.01 0.0 0.022 x 0.028 0.05 0.02
	cylinder 0.03 0.0 0.022 x 0.05 0.008
	color 200 200 200
	cylinder -0.105 0.01 0.01 x 0.006 0.01
	cylinder -0.105 -0.01 0.01 x 0.006 0.01
    }
    popMatrix
}
